using System;
using cAlgo.API;
using cAlgo.API.Indicators; 

namespace cAlgo.Robots
{
    [Robot]
    public class NewRobot : Robot
    {
        [Parameter("Vol", DefaultValue = 10000)]
        public int Vol { get; set; }
		 
		[Parameter("BB_price")]
        public DataSeries BB_price { get; set; }
        
        [Parameter("BB_period", DefaultValue = 21)]
        public int BB_period { get; set; }
        
        [Parameter("dev", DefaultValue = 2)]
        public double dev { get; set; }
        
        [Parameter("BB_type")]
        public MovingAverageType BB_type { get; set; }   
        
        [Parameter("RSI_price")]
        public DataSeries RSI_price { get; set; }
        
        [Parameter("Period_RSI", DefaultValue = 14)]
        public int Period_RSI { get; set; }
        
        [Parameter("Level_UP_RSI", DefaultValue = 70)]
        public int Level_UP_RSI { get; set; }
        
        [Parameter("Level_DOWN_RSI", DefaultValue = 30)]
        public int Level_DOWN_RSI { get; set; }
        
        private BollingerBands BB;
        private RelativeStrengthIndex RSI;
        private Position position1;
        private int a;
        
        protected override void OnStart()
        {
        Print("Welcome to the world of infinite financial possibilities!");
        BB=Indicators.BollingerBands(BB_price,BB_period,dev,BB_type);
        RSI=Indicators.RelativeStrengthIndex(RSI_price,Period_RSI);
        }
    

        protected override void OnTick()
        {
        int bars=MarketSeries.Close.Count-1;
    
        double h=MarketSeries.High[bars-1];
        double l=MarketSeries.Low[bars-1];
       
        double BB1=BB.Bottom[BB.Bottom.Count-1];
        double BB2=BB.Top[BB.Top.Count-1];
        double BB3=BB.Main[BB.Top.Count-1];
        
        double rsi=RSI.Result[RSI.Result.Count-1];

        double Bid=Symbol.Bid;
        double Ask=Symbol.Ask;
        double Point=Symbol.PointSize;
         
        if (Trade.IsExecuting) return;
        
          if (Bid>BB2 && rsi>Level_UP_RSI && a==0)
          {
          Trade.CreateSellMarketOrder(Symbol, Vol);
          Print("Trade SELL was successfully open");
          a=1;
          }
          
          if (Bid<BB1 && rsi<Level_DOWN_RSI && a==0)
          {
          Trade.CreateBuyMarketOrder(Symbol, Vol);  
          Print("Trade BUY was successfully open");
          a=1;
          }    

            foreach (var position in Account.Positions)
            {
            if (position.TradeType==TradeType.Buy && Bid>=BB3)
            Trade.Close(position);     

            if (position.TradeType==TradeType.Sell && Bid<=BB3)
            Trade.Close(position);      
             }    
                
        }
        
        protected override void OnPositionClosed(Position pos)
         {
          a=0;
         }
         
          protected override void OnStop()
        {
         Print("Successful day!");
        }
    }
}